<?php
/*
Plugin Name: WP Summary
Plugin URI: http://www.php-experts.org/wordpress/plugin-wp-summary
Description: Adds a summary at the beginning of every post. Uses H2 and H3 tags to find sections.
Version: 0.2
Author: Didier Sampaolo
Author URI: http://www.php-experts.org/
*/

add_filter('the_content','wp_summary_content');

function wp_summary_content($content) {
	$summary = wp_summarize ($content);
	
	if (strpos($content,'[summary]') !== false) {
		echo str_replace('[summary]',$summary,$content);
	} else {
		echo $summary.$content;
	}
}

function wp_summarize ($content) {
	$pattern = '/\<h([1-3])\>(.*?)\<\/h[1-3]\>/i';
	preg_match_all($pattern, $content, $matches);

	if (isset($matches[0]) && is_array($matches[0]) && !empty($matches[0])) {
		
		$summary =  "Sommaire de cet article: ";

		$sum = $matches[1];
		$max = count($matches[1]);
		$prevDepth = $matches[1][0];
		$summary .= '<ul>';

		for ($i=0;$i<$max;$i++) {
			$depth = $matches[1][$i];

			if ($prevDepth - $depth == 1) { // si on monte d'un cran (h3->h2), on monte d'un </ul>
				$summary .= '</ul>';	
			} elseif ($prevDepth - $depth == -1) { // si on descend d'un cran (h2->h3), on descend d'un <ul>
				$summary .= '<ul>';
			}
			$text = $matches[2][$i];
			// on créé un slug pour l'ancre
			$name = sanitize_title_with_dashes( $text );
			// on affiche le lien dans le sommaire
			$summary .= '<li><a href="#'.$name.'">'.$text.'</a></li>';
			// on ajoute l'ancre nommée dans le <hX>	
			$newPattern = '/\<h'.$depth.'\>'.str_replace('?','.',$text).'\<\/h'.$depth.'\>/i';

			$content = preg_replace($newPattern, '<h'.$depth.'><a name="'.$name.'">'.$text.'</a></h'.$depth.'>',$content);			

			$prevDepth = $depth;
		}	
		$summary .= '</ul>';
	}
	//echo $summary;

	return $summary;
}

add_shortcode( 'summary', 'shortcode_wp_summary' );

function shortcode_wp_summary($param) {
	echo '!'; return '§';	

global $post;
	$content = get_the_content();
	$summary = wp_summarize($content);
	return $summary;
}

?>
